
from scipy import *
from pylab import *
import time


def set_circle(arr,value,center,r):
   for x in range(-r,r): 
      for y in range(-r,r):
	 if (x**2+y**2) > r**2: continue
	 arr[center[0]+x,center[1]+y] = value
   return


n = 64
invsigsq = 0.01
n2 = n/2

#local/grainy update, which isn't going to be used:
p = zeros((n,n),dtype=float)
p[0,n-1]= p[1,0]= p[n-1,0]= p[0,1]=1/4.0

#filter = fft2(p)

#smoother gaussian updata:
filtery = matrix(array([(exp(-(k**2)*invsigsq) + exp(-((n-k)**2)*invsigsq)) for k in range(n)],dtype=float))
filterx = transpose(filtery)

filter = array(filterx*filtery)

p = zeros((n,n),dtype=float)
 
mask = ones((n,n))

set_circle(mask,0.0, (n/2,n/2), 8)

#turn on interactive graphics:
ion()

for k in range(2000):
   #x = raw_input("Press Enter")
   #time.sleep(0.1)
   pk = fft2(p)
   pk = pk*filter
   p = real(ifft2(pk))
   p = p * mask
   p[:,n-10:] = 1
   p[:,:10] = -1
   imshow(p)
   #cla()
   #plot(p[n/2+20,:])
   show()


