
from scipy import *
from pylab import *
import time


def set_circle(arr,value,center,r):
   for x in range(-r,r): 
      for y in range(-r,r):
	 if (x**2+y**2) > r**2: continue
	 arr[center[0]+x,center[1]+y] = value
   return


n = 128
dt = 0.1
invsigsq = 0.05
n2 = n/2

p = zeros((n,n),dtype=float)
#p[0,n-1]= p[1,0]= p[n-1,0]= p[0,1]=1/4.0
p[0,n-1]= p[1,0]= p[n-1,0]= p[0,1]=1/6.0
p[n-1,n-1]= p[1,1]= p[n-1,1]= p[1,n-1]=1/12.0

#filter = fft2(p)

filtery = matrix(array([(exp(-(k**2)*invsigsq) + exp(-((n-k)**2)*invsigsq)) for k in range(n)],dtype=float))
filterx = transpose(filtery)

filter = array(filterx*filtery)
#filter = fft2(p)

p = zeros((n,n),dtype=float)
set_circle(p,1.0, (n/2,n/2), 16)

masky = matrix(array([i/n2 for i in range(n)],dtype=float))

 
mask = ones((n,n))

for x in range(n/16): 
   set_circle(mask,0.0, (x*16,n/2), 2)

#mask[:,n/2:] = 1

#p[n/2,n/2-10] = -1
#p[n/2+20,n/2+20] = 1
ion()
for k in range(500):
   #x = raw_input("Press Enter")
   #time.sleep(0.1)
   pk = fft2(p)
   pk = pk*filter
   p = real(ifft2(pk))
#   p = p * mask
#   p[:,n-10:] = 1
   imshow(p)
   #cla()
   #plot(p[n/2+20,:])
   show()


